# sinmat(N,freq,theta) : return [x,s] sin grating with given frequency 
#	and orientation
#	N : size of vector
#	The sin wave's origin should be in the center of the vector

function sm = sinmat (N,freq,theta)

  sm = zeros(N,N);

  cx = round(N/2);
  cy = round(N/2);

  to_rad = pi / 180.0;


  ymat = ((1:N)'*(zeros(1,N).+1)).-round(N/2);
  xmat = ymat';

  distmat = sqrt(xmat.*xmat + ymat.*ymat);

  alpha1 = atan(ymat(1:cx-1,1:cy-1)./xmat(1:cx-1,1:cy-1));
  alpha2 = atan(ymat(cx+1:N,1:cy-1)./xmat(cx+1:N,1:cy-1));
  alpha3 = atan(ymat(1:cx-1,cy+1:N)./xmat(1:cx-1,cy+1:N));
  alpha4 = atan(ymat(cx+1:N,cy+1:N)./xmat(cx+1:N,cy+1:N));

  # y = ax
  signmat = flipud((ymat <= ((tan(theta*to_rad)*xmat).+0.000001)).-2)/2.0;
  
  # distance
  sm = signmat;


  alpha = [ alpha1, zeros(rows(alpha1),1), alpha2];
  alpha = [ alpha ; zeros(1,N)];
  alpha = [ alpha ; alpha3, zeros(rows(alpha3),1), alpha4];

  sm = sin(distmat .* sin(signmat .* (alpha.+((90-theta)*to_rad))));

endfunction

