## usage: [Emax1] = circaperturetheta(Emax)
##
##	Emax=absolute orientation value matrix
##     
##
##      Finds the circular aperture for the specified Emax file
##     
##      By Subramonia Sarma <sps8556@cs.tamu.edu> on May 20 2002

function [Emax1] = circaperturetheta(Emax)
      
         # get size of matrix
	[rows, cols] = size(Emax);

        
        printf("cols = %d , rows = %d\n",cols,rows);
        

	Emax1 = zeros(rows,cols);   	
	
	xc=ceil(rows/2);
	yc=ceil(cols/2);

        printf("xc = %d , yc = %d\n",xc,yc);

	if (rows < cols)
	r=rows/2
	else
	r=cols/2;
	endif

	for i=1:rows
	for j=1:cols
	
        if (((abs(i-xc)**2)+(abs(j-yc)**2)) > (r**2))
	Emax1(i,j)=-1;
	else
	Emax1(i,j)=Emax(i,j);
	endif
	endfor
        endfor
            
	#save -ascii img1 nV;	

 
 endfunction

