# usage: G = gaussian2 (n, u, v) 
# 	returns a 2D Gaussian matrix of size n x n, centered at the
# 	middle. u is the mean, and v is the variance.

function G = gaussian2(n, u, v)

	c = round(n/2);

	x = (1:n)'*(zeros(1,n).+1).-c;
	y = x';

	d = sqrt(x.*x + y.*y);

	G = normal_pdf(d, u, v);

endfunction
