## usage:  phideltheta(nV,E)
##
##	nV: p x q matrix (energy values of edge elements)
##      E : p x q matric (orientations of edge elements)
##
##      Finds the phi, delta, theta values from the given nV matrix
##      and dumps them to the file "phideltheta.dmp"
##
##

function phideltheta(nV,E)

        # get size of matrix
	[rows, cols] = size(nV);

	printf("cols = %d , rows = %d\n",cols,rows);

        #open output file for writing
        outfile=fopen("phideltheta.dmp","w");

        #initialize variables
        curr=0;
        next=0;
        count=0;      
 
    #begin looping comparing every edge element to every other element and
    #calculate the phi, delta, theta values
     while (curr<(rows*cols))
     while ((next<(rows*cols))&&(curr<(rows*cols)))

   if ((nV((floor(next/cols)+1),((next-(cols*(floor(next/cols))))+1))!=0)
     && (nV((floor(curr/cols)+1),((curr-(cols*(floor(curr/cols))))+1))!=0))
        if (curr!=next)
    
     #printf("next = %d\n",next);
   
     theta1=(E((floor(next/cols)+1),((next-(cols*(floor(next/cols))))+1))*10)-10;
     theta2=(E((floor(curr/cols)+1),((curr-(cols*(floor(curr/cols))))+1))*10)-10;

     theta=abs(theta1 - theta2);

     if ((floor(next/cols)) > (floor(curr/cols)))
     
      if ((next-cols*(floor(next/cols))) > (curr-cols*(floor(curr/cols)))) 
   
         th=atan(abs((floor(next/cols))-(floor(curr/cols)))/abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols)))));
         phi=(180/pi)*((2*pi)-th);
         d=abs((floor(next/cols))-(floor(curr/cols)))/sin(th);
      
      endif
      
      if ((next-cols*(floor(next/cols))) < (curr-cols*(floor(curr/cols)))) 
      
      	 th=atan(abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))))/abs((floor(next/cols))-(floor(curr/cols))));
         phi=(180/pi)*(((3*pi)/2)-th);
         d=abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))))/sin(th);
            
      endif
      
      if ((next-cols*(floor(next/cols))) == (curr-cols*(floor(curr/cols)))) 
      
         phi=270;
         d=abs((floor(next/cols))-(floor(curr/cols)));
      
      endif
      
    endif
    
     if ((floor(next/cols)) < (floor(curr/cols)))
         
          if ((next-cols*(floor(next/cols))) > (curr-cols*(floor(curr/cols)))) 
       
             th=atan(abs((floor(next/cols))-(floor(curr/cols)))/abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols)))));
             phi=(180/pi)*th;
             d=abs((floor(next/cols))-(floor(curr/cols)))/sin(th);
          
          endif
          
          if ((next-cols*(floor(next/cols))) < (curr-cols*(floor(curr/cols)))) 
          
             th=atan(abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))))/abs((floor(next/cols))-(floor(curr/cols))));
             phi=(180/pi)*((pi/2)-th);
             d=abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))))/sin(th);
                
          endif
          
          if ((next-cols*(floor(next/cols))) == (curr-cols*(floor(curr/cols)))) 
          
             phi=90;
             d=abs((floor(next/cols))-(floor(curr/cols)));
          
          endif
          
    endif
    
    if ((floor(next/cols)) < (floor(curr/cols)))
    
         if ((next-cols*(floor(next/cols))) > (curr-cols*(floor(curr/cols)))) 
         
             phi=0;
             d=abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))));
             
         endif
         
         if ((next-cols*(floor(next/cols))) > (curr-cols*(floor(curr/cols))))
         
             phi=180;
	     d=abs((next-cols*(floor(next/cols)))-(curr-cols*(floor(curr/cols))));
	              
         endif
         
     endif
   else
   
      phi=0;
      d=0;
      theta=0;
   endif
    
   #write phi, d, theta to output file
     fprintf(outfile,"%4.4f %4.4f %4.4f\n",phi,d,theta);
     count=count+1;
   endif 

   if (nV((floor(curr/cols)+1),((curr-(cols*(floor(curr/cols))))+1))==0)
        curr=curr+1;
        next=0;
   else
      #increment next
     next=next+1;
   endif
 

  endwhile
   
  #increment current
   curr=curr+1;

  #set next to beginning
   next=0;
  
  endwhile

   #close output file
   fclose(outfile);

  printf("Total no: of phi,del,theta values = %d\n",count);
 
 endfunction
