## usage:  phideltheta_matr2(nV,E,img)
##
##	nV2: p x q matrix (energy values of edge elements)
##      E2 : p x q matrix (orientations of edge elements)
##
##      Finds the phi, delta, theta values from the given nV matrix
##      and dumps them to the file "<imagefile>.dmp"
##	Printout with theta 45 degree increment, theta2, # of counts. 
##

function [outputfile1 outputfile2] = phideltheta_matr2(nV2,E2,img)
      
        # get size of matrix
	[rows, cols] = size(nV2);

        nV=zeros(rows+2, cols+2);
        nV(2:rows+1,2:cols+1)=nV2;
        E=zeros(rows+2, cols+2);
        E(2:rows+1,2:cols+1)=E2;

        nV(1,2:cols+1)=nV2(rows,1:cols);
        nV(rows+2,2:cols+1)=nV2(1,1:cols);
        nV(2:rows+1,1)=nV2(1:cols,cols);
        nV(2:rows+1,cols+2)=nV2(1:cols,1);

        nV(1,1)=nV2(rows,cols);
        nV(rows+2,cols+2)=nV2(1,1);
        nV(1,cols+2)=nV2(rows,1);
        nV(rows+2,1)=nV2(1,cols);

        E(1,2:cols+1)=E2(rows,1:cols);
        E(rows+2,2:cols+1)=E2(1,1:cols);
        E(2:rows+1,1)=E2(1:cols,cols);
        E(2:rows+1,cols+2)=E2(1:cols,1);

        E(1,1)=E2(rows,cols);
        E(rows+2,cols+2)=E2(1,1);
        E(1,cols+2)=E2(rows,1);
        E(rows+2,1)=E2(1,cols);
 
        rows=rows+2;
        cols=cols+2;

        img=strcat(img,".new.dmp");
        printf("Image = '%s'\n",img);
	printf("cols = %d , rows = %d\n",cols,rows);
      
        #open output file for writing
        outfile=fopen(img,"w");
        tmpfile=fopen("idmat.tmp","w");

        #initialize variables
        count=1;
        idtmp=[0,0];
        idmat=[0,0];      
      
	for i=1:rows
	for j=1:cols
	  if (nV(i,j) > 0)
            idtmp=vec([i,j])';
            idmat=[idmat;idtmp];
            count=count+1;
          endif
        endfor
        endfor
            
        outputfile1=zeros(rows,rows*rows*rows);

        printf("Count = %d\n",count);
        for i=1:count
          fprintf(tmpfile,"%d %d\n",idmat(i,1),idmat(i,2));
        endfor   

        fclose(tmpfile);

        #initialize matrices and variables
        curr=[0,0];
        next=[0,0];
        i=2;
        j=2;
        num=0;

        count2=1;
        while (i<=count)
   
        curr=[idmat(i,1),idmat(i,2)];

        while (j<=count)

        next=[idmat(j,1),idmat(j,2)];

        d=sqrt(((next(1)-curr(1))**2)+((next(2)-curr(2))**2));

        if ((curr(1)!=next(1))||(curr(2)!=next(2))) #1

        #if (d < 2) #2
   
          #printf("next = %d\n",next);
   
          theta1=(E(curr(1),curr(2))-1)*45;
          theta2=(E(next(1),next(2))-1)*45;

          #theta=abs(theta1 - theta2);
 
          if (theta1 <= theta2)
            theta=theta2 - theta1;
          else
            theta=180-theta1 + theta2;
          endif
            
          if theta == 180
            theta = 0;
          endif
         
          if (next(1) > curr(1)) #3
     
            if (next(2) > curr(2)) #4
   
              th=atan(abs(next(1)-curr(1))/abs(next(2)-curr(2)));
              #phi1=(180/pi)*((2*pi)-th);
              #phi=phi1;
              phi1=(180/pi)*th;
	      if (theta1+phi1>180)
                phi=360-(phi1+theta1);
              else
                phi=180-(phi1+theta1);
              endif
              #if (phi < 0)
              #   phi = phi + 180;
              #endif
              #d=abs(next(1)-curr(1))/sin(th);
      
            endif #4
      
            if (next(2) < curr(2)) #5
      
      	      th=atan(abs(next(1)-curr(1))/abs(next(2)-curr(2)));
              #phi1=(180/pi)*(((3*pi)/2)-th);
              #phi=phi1;
              phi1=(180/pi)*th;

	      if (phi1>=theta1)
                phi=phi1-theta1;
              else
                phi=180+phi1-theta1;
              endif

              #if (phi < 0)
              #   phi = phi + 180;
              #endif
              #d=abs(next(2)-curr(2))/sin(th);
            
            endif #5
      
            if (next(2) == curr(2)) #6 
      
              #phi=270;
              #phi=abs(90-theta1);

              if (theta1 <= 90)
                phi=90-theta1;
              else
                phi=270-theta1;
              endif

              #d=abs(next(1)-curr(1));
      
            endif #6
      
          endif #3
    
          if (next(1) < curr(1)) #7
         
            if (next(2) > curr(2)) #8
       
              th=atan(abs(next(1)-curr(1))/abs(next(2)-curr(2)));
              phi1=(180/pi)*th;
              #phi=phi1;

              if (theta1<=phi1)
                phi=phi1-theta1;
              else
                phi=180+phi1-theta1;
              endif

              #d=abs(next(1)-curr(1))/sin(th);
          
            endif #8
          
            if (next(2) < curr(2)) #9
          
              th=atan(abs(next(1)-curr(1))/abs(next(2)-curr(2)));
              #phi1=(180/pi)*((pi/2)+th);
              #phi=phi1;
              phi1=(180/pi)*th;
	   
              if ((theta1+phi1)<=180)
                phi=180-phi1-theta1;
              else
                phi=360-phi1-theta1;
              endif

              #d=abs(next(2)-curr(2))/sin(th);
                
            endif #9
          
            if (next(2) == curr(2)) #10

              #phi=90;
              #phi=abs(90-theta1);

              if (theta1 <= 90)
                phi=90-theta1;
              else
                phi=270-theta1;
              endif

              #d=abs(next(1)-curr(1));
          
            endif #10
          
          endif #7
    
          if (next(1) == curr(1)) #11
    
            if (next(2) > curr(2)) #12 
              #phi=0;
              phi=180-theta1;
              #d=abs(next(2)-curr(2));
            endif #12
         
            if (next(2) < curr(2)) #13
              #phi=180;
              phi=180-theta1;
	      #d=abs(next(2)-curr(2));          
            endif #13
         
          endif #11

          if (phi == 180)
            phi = 0;
          endif

          #write phi, d, theta to output file
          fprintf(outfile,"%d %d %d %d %d %d %d %d %d\n",phi,d,theta,theta2,curr(1),curr(2),next(1),next(2),count2);
          outputfile1(curr(1),(curr(2)-1)*rows*rows+(next(1)-1)*rows+next(2))=count2;

          outputfile2(count2,1)=floor(phi);
          outputfile2(count2,2)=floor(d);
          outputfile2(count2,3)=floor(theta);
          outputfile2(count2,4)=theta2;
          outputfile2(count2,5)=curr(1);
          outputfile2(count2,6)=curr(2);
          outputfile2(count2,7)=next(1);
          outputfile2(count2,8)=next(2);
          outputfile2(count2,9)=count2;
          count2=count2+1;

        #endif #2

        #else

          #phi=0;
          #d=0;
          #theta=0;

        endif #1
    
        #write phi, d, theta to output file
        #fprintf(outfile,"%d %d %d\n",phi,d,theta);
        num=num+1;
      
        j=j+1;

        endwhile
   
        i=i+1;
        j=2;

        endwhile
   
        #close output file
        fclose(outfile);

        %printf("Total no: of phi,del,theta values = %d\n",num);
 
endfunction

