## Copyright (C) 2000 William Hunter
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## plt2gif:
## Converts the current plot to GIF format (.gif)
## by envoking GNUPLOT commands from OCTAVE. The GNUPLOT terminal is
## reset to the default (X11) after execution of the script.
##
## Usage: plt2gif("filename")
##
## Example:
## USER input: plt2gif("papaya")
## OCTAVE output: papaya.gif (saved in your working directory)

## Author: W. Hunter
## Created: 25 November 2001

function plt2gif (filename)
 gset terminal gif small size 640,480 xffffff x000000 x404040 xff0000 xffa500 x66cdaa;
 eval(sprintf("gset output \"%s%s\" \n",filename,".gif"));
 replot;
 gset terminal X11;
 printf("\nWrote %s/%s%s \n \n",pwd,filename,".gif");

endfunction

