# M = or_energy(X,k,freq,th)
#	return orientation energy of X
#	1. dog filter with kernel size k x k
#	2. convolve with sin and cos gabor of size k x k , freq and orientation
#		theta

function M = or_energy(X,k,freq,th)

	D = dogfilter(X,k);
	
	M = real(conv2(D,gabor(k,k,"sin",th,freq),"same")).^2 + real(conv2(D,gabor(k,k,"cos",th,freq),"same")).^2;

endfunction
