#!/usr/bin/perl

# input : 2d matrix

if ($#ARGV!=4) {
  print "usage: orjustline2 <cols> <rows> <mag> <skip> <inputfile.mat>  > <outputfile>\n";
  exit(0);
}

$cols = $ARGV[0];
$rows = $ARGV[1];
$mag  = $ARGV[2];
$skip = $ARGV[3];
$inputfile = $ARGV[4];


# initialize huge matrix
for ($j=0; $j<$rows*$mag; ++$j) {
  for ($i=0; $i<$cols*$mag; ++$i) {
	$matrix[$i][$j] = 0.0;
  }
}

$line = 0;
open(MATFP,"$inputfile");
while ($str=<MATFP>) {
  chop $str;
  @values = split(/[\s]+/,$str);

  for ($i=0; $i<$cols; ++$i) {
	&or_plus_line($line,$i,$mag,$values[$i],$skip);
  } 
  $line ++;
}
close MATFP;

# print huge matrix
for ($j=0; $j<$rows*$mag; ++$j) {
  for ($i=0; $i<$cols*$mag; ++$i) {
	print "$matrix[$i][$j] ";
  }
  print "\n";
}


sub or_plus_line {

    my ($line,$col,$mag,$val,$skip) = @_;
    my ($i, $j, $x1, $x2, $y1, $y2);

    # Draw background
    $x1 = $col*$mag;
    $x2 = ($col+1)*$mag-1;
    $y1 = $line*$mag;
    $y2 = ($line+1)*$mag-1;

    for ($j=$y1; $j<=$y2; ++$j) {
	for ($i=$x1; $i<=$x2; ++$i) {
		$matrix[$i][$j] = 0.0;
 	}
    }

  if ($line%$skip==0 && $col%$skip==0){
    # select line color
    my $line_col = $val+0.5;
    if ($line_col >= 1.0) { $line_col -= 1.0; }

    # plot line
    # - : 0 degree, / : 45 degrees, | : 90 degrees, ...
    my $a = &tan($val*3.141592);
    
    my $half = $mag/2.0;
    if ($skip==1) { $half=0; }
    for ($j=-$half; $j<$mag+$half; ++$j) {
	for ($i=-$half; $i<$mag+$half; ++$i) {
		my $x=$i;
		my $y=$j; # rectify coordinate
		my $b=$mag/2.0-$a*$mag/2.0;
		my $ycoord = $a * $x + $b;
		my $xcoord = ($y-$b)/($a+0.000000001);
		if (abs($y-$ycoord)<1.0 || abs($x-$xcoord)<1.0) {
			$matrix[$x1+$i][$y1+$j] = 1.0;
		}
		
	}
    }
  }
}

sub tan { sin($_[0]) / cos($_[0])  }















