#!/usr/bin/perl
require "getopts.pl";
&Getopts('v:z:');

$usage = <<EOF;
usage: procor.pl [-v 1|2] [-z zoom] <simulationfile-basename>

	-v : view ppm images - for map1 or map2
	-z : zoom factor

	ex: procor.pl nov8-1
		-- to get orientation map from nov8-1.conf processed
EOF

if ($#ARGV!=0) {
	print $usage;
	exit;
}


$zoom = $opt_z?$opt_z:3;

if ($opt_v==1) {
	`xv -expand $zoom -raw $ARGV[0]*map1-0*.or.ppm`;
	`xv -expand $zoom -raw $ARGV[0]*map1-0*.or.selec.ppm`;
	exit;
} elsif ($opt_v==2) {
	`xv -expand $zoom -raw $ARGV[0]*map2-0*.or.ppm`;
	`xv -expand $zoom -raw $ARGV[0]*map2-0*.or.selec.ppm`;
	exit;
}

@orfiles = `ls *map1-0.or | xargs --replace=R basename R .or; ls *map2-0.or | xargs --replace=R basename R .or`;

for $file (@orfiles) {
	chop $file;
	if (! (-f "${file}.or.ppm")) {
		`prochsvmat ${file}.or`;
	}
	if (! (-f "${file}.or.selec.ppm")) {
		`prochsvmat4 1.0 ${file}.or ${file}.orselec`;
	}
} 
